/* Figura 2D com 3 ou 4 vertices, poligono 2D */



#include <string.h>
#include <stdio.h>

#include "defs.h"
#include "Pol2d.h"



/* construtor - inicia vertices com 0
**********************************************************/
CPol2D::CPol2D ()
{
	memset ( (void*) m_anX, 0, 4 * sizeof ( INT16 ) );
	memset ( (void*) m_anY, 0, 4 * sizeof ( INT16 ) );
}



/* construtor - define explicitamente valores individuais para cada vertice
**********************************************************/
CPol2D::CPol2D ( INT16 nX1, INT16 nY1, INT16 nX2, INT16 nY2,
					  INT16 nX3, INT16 nY3, INT16 nX4, INT16 nY4 )
{
	m_anX [ 0 ] = nX1;
	m_anY [ 0 ] = nY1;
	m_anX [ 1 ] = nX2;
	m_anY [ 1 ] = nY2;
	m_anX [ 2 ] = nX3;
	m_anY [ 2 ] = nY3;
	m_anX [ 3 ] = nX4;
	m_anY [ 3 ] = nY4;

   mDefCentro ();
}



/* construtor - define implicitamente valores individuais para cada vertice
**********************************************************/
CPol2D::CPol2D ( CPol2D &oPol2D )
{
	m_anX [ 0 ] = oPol2D.m_anX [ 0 ];
	m_anY [ 0 ] = oPol2D.m_anY [ 0 ];
	m_anX [ 1 ] = oPol2D.m_anX [ 1 ];
	m_anY [ 1 ] = oPol2D.m_anY [ 1 ];
	m_anX [ 2 ] = oPol2D.m_anX [ 2 ];
	m_anY [ 2 ] = oPol2D.m_anY [ 2 ];
	m_anX [ 3 ] = oPol2D.m_anX [ 3 ];
	m_anY [ 3 ] = oPol2D.m_anY [ 3 ];

   mDefCentro ();
}



/* Define valores para cada vertice
**********************************************************/
void CPol2D::mAtr ( INT16 nX1, INT16 nY1, INT16 nX2, INT16 nY2,
						  INT16 nX3, INT16 nY3, INT16 nX4, INT16 nY4 )
{
	m_anX [ 0 ] = nX1;
	m_anY [ 0 ] = nY1;
	m_anX [ 1 ] = nX2;
	m_anY [ 1 ] = nY2;
	m_anX [ 2 ] = nX3;
	m_anY [ 2 ] = nY3;
	m_anX [ 3 ] = nX4;
	m_anY [ 3 ] = nY4;

   mDefCentro ();
}



/* Mostra na tela os vertices do poligono
**********************************************************/
void CPol2D::mMostra ()
{
	for ( INT ncV = 0; ncV < 4; ncV ++ )

		printf ( "%d  %d\n", m_anX [ ncV ], m_anY [ ncV ] );
}



/* Define o ponto central, medio, de todas as componentes do poligono.
**********************************************************/
void CPol2D::mDefCentro ()
{
	INT
   	nSomaX = 0,
   	nSomaY = 0;

   // faz a soma dos valores
   for ( INT16 ncC = 0; ncC < 4; ncC ++ ) {

   	nSomaX += m_anX [ ncC ];
   	nSomaY += m_anY [ ncC ];
	}

   // divide pelo numero de elementos (/ 4 equivale a >> 2)
   m_anX [ CENTRO ] = nSomaX >> 2;
   m_anY [ CENTRO ] = nSomaY >> 2;
}



/* Define o ponto central, medio, das componentes X.
**********************************************************/
INT16 CPol2D::mRetCentroX ()
{
	INT
   	nSoma = 0;

   // faz a soma dos valores
   for ( INT16 ncC = 0; ncC < 4; ncC ++ )
   	nSoma += m_anX [ ncC ];

   // divide pelo numero de elementos
   m_anX [ CENTRO ] = nSoma >> 2;

   return m_anX [ CENTRO ];
}



/* Define o ponto central, medio, das componentes Y.
**********************************************************/
INT16 CPol2D::mRetCentroY ()
{
	INT
   	nSoma = 0;

   // faz a soma dos valores
   for ( INT16 ncC = 0; ncC < 4; ncC ++ )
   	nSoma += m_anY [ ncC ];

   // divide pelo numero de elementos
   m_anY [ CENTRO ] = nSoma >> 2;

   return m_anY [ CENTRO ];
}
